-- Phrase variables
BINDING_HEADER_BANKGUI = "BankGUI v2.3";
BINDING_NAME_BANKGUITOGGLE = "Show / Hide BankGUI Window";

BANKGUIS_TO_DISPLAY = 18;
FRIENDS_FRAME_BANKGUI_HEIGHT = 16;

BANKGUI_TABNAME			= "Bank";
BANKGUI_TITLE			= "BankGUI";
BANKGUI_GUILD			= "Guild";
BANKGUI_DELETE			= "Delete";
BANKGUI_DELETES			= "Delete Items";

BANKGUI_OWNER			= "Owner";
BANKGUI_ITEM			= "Item name";
BANKGUI_AMOUNT			= "Amount";
BANKGUI_TYPE			= "Item Type";
BANKGUI_LEVEL			= "Item Level";
BANKGUI_INVENT			= "Inventory";
BANKGUI_EQUIP			= "Equipslot";
BANKGUI_VENDOR			= "Vendor value";

BANKGUI_GOLD_BANK = "Total Gold |cffffffff%.2f|r";
BANKGUI_GOLD_GUILD = "Gold |cffffffff%.2f|r";

BANKGUI_FACTION_COLORS = {
	[FACTION_ALLIANCE] = { 0.25, 0.25, 0.75 },
	[FACTION_HORDE] = { 0.75, 0.25, 0.25 },
	["Unknown"] = { 0.75, 0.75, 0.75 },
}

BANKGUI_HELP = {
	{ BANKGUI_TITLE .." help:", 1, 0.5, 0 },
	{ " Go to Social |cffffff80(O)|r and select the Bank tab at the bottomright of the window.", 0.5, 1, 1 },
	{ " There you see a list of items that are in bags/bank/equiped on all your characters (per account, per realm).", 0.5, 1, 1 },
	{ " |cffffff80NOTE:|r Items only get added/updated to the list when you open your Bank/Tradeskill window.", 0.5, 1, 1 },
	{ " ", 1, 1, 1 },
	{ " |cffffff80/bank|r Shows / Hides the BankGUI window", 1, 1, 1 },
	{ " |cffffff80/bank help|r show help text", 1, 1, 1 },
	{ " |cffffff80/bank update|r Update Currency, Friendlist and Glyphs", 1, 1, 1 },
	{ " |cffffff80/bank detach|r Detach the BankGUI window from the Social pane", 1, 1, 1 },
	{ " |cffffff80/bank attach|r Attach the BankGUI window to the Social pane", 1, 1, 1 },
	{ " |cffffff80/bank sort|r Sort BankGUI items (normally only done when opening bank)", 1, 1, 1 },
	{ " |cffffff80/bank check|r Check for itemstacks that are not maximized (Bags/Bank if opened)", 1, 1, 1 },
	{ " |cffffff80/bank grey|r Check for 'grey' quality items in your bags", 1, 1, 1 },
	{ " ", 1, 1, 1 },
	{ "Hyperlink in Chat windows:", 1, 0.5, 0 },
	{ " |cffffff80Shift-Click|r Put the link text in the Filter textbox", 1, 1, 1 },
	{ " |cffffff80Alt-Click|r Put the link text in the Farm textbox", 1, 1, 1 },
	{ " ", 1, 1, 1 },
	{ "Hoover over Items:", 1, 0.5, 0 },
	{ " |cffffff80Alt-Hoover|r Put the itemname in the Farm textbox", 1, 1, 1 },
	{ " |cffffff80Alt+Shift-Hoover|r Put the itemname in the Filter textbox", 1, 1, 1 },
	{ " ", 1, 1, 1 },
	{ "Sort Order:", 1, 0.5, 0 },
}

BANKGUI_TYPE_CURRENCY  = "-8";
BANKGUI_TYPE_FRIENDS   = "-7";
BANKGUI_TYPE_GLYPHS    = "-6";
BANKGUI_TYPE_FARMS     = "-5";
BANKGUI_TYPE_TRADELINK = "-4";


BANKGUI_KEEPTRACKOF = "KeepTrackOf";
BANKGUI_KEEPGUILD   = "Guild Items";
BANKGUI_KEEPITEMS   = "Items";
BANKGUI_KEEPTRADE   = "TradeSkills";
BANKGUI_KEEPPROFS   = "Profession Links";
BANKGUI_KEEPGLYPS   = "Glyphs";
BANKGUI_KEEPFRIEND  = "Friends";
BANKGUI_KEEPCURR    = "Currency";
BANKGUI_SORTTITLE1  = "1st Sort Order";
BANKGUI_SORTTITLE2  = "2nd Sort Order";
BANKGUI_SORTTITLE3  = "3rd Sort Order";
BANKGUI_SORTNAME1   = "Item name";
BANKGUI_SORTNAME2   = "Owner / Player name";
BANKGUI_SORTNAME3   = "Amount";
BANKGUI_SORTNAME4   = "Item Level";
BANKGUI_SORTNAME5   = "None";
BANKGUI_FACTION     = "Show both Factions";
BANKGUI_TOTALS      = "Show only Totals";
BANKGUI_TOOLTIPS    = "Tooltips";
BANKGUI_ALTHOOVER   = "Use 'Alt' Hoover";
BANKGUI_BANKSKIN    = "BankGUI Skin";
BANKGUI_TRANSPARENT = "Transparent";
BANKGUI_BARCOLOR    = "Bar Color ...";
BANKGUI_BACKCOLOR   = "Background Color ...";
BANKGUI_RESETCOLORS = "Reset Colors";

BANKGUI_OPTIONS_MENU = {
	[BANKGUI_KEEPTRACKOF] = {
		[BANKGUI_KEEPGUILD] = {},
		[BANKGUI_KEEPITEMS] = {},
		[BANKGUI_KEEPTRADE] = {},
		[BANKGUI_KEEPPROFS] = {},
		[BANKGUI_KEEPGLYPS] = {},
		[BANKGUI_KEEPFRIEND] = {},
		[BANKGUI_KEEPCURR] = {},
	},
	[BANKGUI_SORTTITLE1] = {
		[BANKGUI_SORTNAME1] = {},
		[BANKGUI_SORTNAME2] = {},
		[BANKGUI_SORTNAME3] = {},
		[BANKGUI_SORTNAME4] = {},
		[BANKGUI_SORTNAME5] = {},
	},
	[BANKGUI_SORTTITLE2] = {
		[BANKGUI_SORTNAME1] = {},
		[BANKGUI_SORTNAME2] = {},
		[BANKGUI_SORTNAME3] = {},
		[BANKGUI_SORTNAME4] = {},
		[BANKGUI_SORTNAME5] = {},
	},
	[BANKGUI_SORTTITLE3] = {
		[BANKGUI_SORTNAME1] = {},
		[BANKGUI_SORTNAME2] = {},
		[BANKGUI_SORTNAME3] = {},
		[BANKGUI_SORTNAME4] = {},
		[BANKGUI_SORTNAME5] = {},
	},
	{
		["name"] = BANKGUI_FACTION,
		["checkable"] = true,
	},
	{
		["name"] = BANKGUI_TOTALS,
		["checkable"] = true,
	},
	{
		["name"] = BANKGUI_TOOLTIPS,
		["checkable"] = true,
	},
	{
		["name"] = BANKGUI_ALTHOOVER,
		["checkable"] = true,
	},
	{
		["name"] = BANKGUI_BANKSKIN,
		["checkable"] = true,
	},
	{
		["name"] = BANKGUI_TRANSPARENT,
		["checkable"] = true,
	},
	{
		["name"] = BANKGUI_BARCOLOR,
		["checkable"] = false,
	},
	{
		["name"] = BANKGUI_BACKCOLOR,
		["checkable"] = false,
	},
	{
		["name"] = BANKGUI_RESETCOLORS,
		["checkable"] = false,
	},
}


-- Global variables

bank_chat = ChatFrame1;
bank_playername = nil;
bank_playerfaction = nil;
bank_guildname = nil;
bank_guildcolor_on = "|cffffffff";
bank_guildcolor_of = "|cffa0a0a0";
bank_frame_opened = false;
bank_craft_casting = false;
bank_ahopened = false;

bank_numtab = 0;

bank_crafts = {
	["Milling"] = true,
	["Prospecting"] = true,
};

TypesIndex = 1;

Item_NoDelete = {
	["-4"] = "TradeLink",
};

BankGUI = {};

BankList = {};
BankFilter = {};
BankTotals = {};

BankListPlayers = {};
BankFactionColors = {};

BankListGuildInfo = {};

BankListItems = {};
BankListGuildItems = {};
BankListCurrency = {};
BankListFriends = {};
BankListGlyphs  = {};
BankListFarms = {};

BankListOptions = {};

BankListStock = {};

BankListFL = {};

Wisp_Data = {};



function BankGUI_OnHyperlinkClick(_, _, linktext, mousebutton)
	if mousebutton and linktext and not bank_ahopened then
		if IsAltKeyDown() then
			if not BankGUIFrame:IsVisible() then BankGUI:ToggleTab() end
			BankGUIFarmFrame:Show();
			BankGUIFarmItemBox:SetText("");
			BankGUIFarmItemBox:Insert(linktext);
			BankGUIFarmItemBox:SetCursorPosition(0);
			if BankGUIFarmAmountBox:GetNumber() == 0 then BankGUIFarmAmountBox:Insert("1") end
			BankGUIFarmAmountBox:SetFocus();
		elseif IsShiftKeyDown() then
			linktext = GetItemInfo(linktext);
			if linktext then
				BankGUIFrame:Show();
				BankGUIFilterTextBox:SetText("");
				BankGUIFilterTextBox:Insert(linktext);
				BankGUIFilterTextBox:SetCursorPosition(0);
			end
		end
	end
end


function BankGUI_OnHyperlinkEnter(_, arg2, linktext, mousebutton)
	if not BankListOptions[GetRealmName()][1][BANKGUI_TOOLTIPS] then return end
	if string.find(arg2, "player:") ~= nil then
		local i, j, bank_hyperlinkplayer = string.find(arg2, "player:");
		if i ~= nil then i = string.find(arg2, ":", j+1) end
		if i ~= nil then
			bank_hyperlinkplayer = string.sub(arg2, j+1, i-1);
			if bank_hyperlinkplayer == bank_playername then return end
			if BankListFL[bank_hyperlinkplayer] then
				GameTooltip:SetOwner(this, "ANCHOR_CURSOR");
				if BankListFL[bank_hyperlinkplayer]["level"] ~= nil then
					GameTooltip:AddLine( format("|cffff8000Level|r |cffffffff%i|r", BankListFL[bank_hyperlinkplayer]["level"]) );
				end
				if BankListFL[bank_hyperlinkplayer]["class"] ~= nil then
					GameTooltip:AddLine( format("|cffff8000Class|r |cffffffff%s|r", BankListFL[bank_hyperlinkplayer]["class"]) );
				end
				if BankListFL[bank_hyperlinkplayer]["note"] ~= nil then
					GameTooltip:AddLine( format("|cffff8000Note|r |cffffffff%s|r", BankListFL[bank_hyperlinkplayer]["note"]) );
				end
				GameTooltip:Show();
				return;
			end
			GameTooltip:Show();
		end
	elseif string.find(arg2, "item:") ~= nil then
		local itemname, itemlink = GetItemInfo(linktext);
		if BankListStock[itemname] then
			GameTooltip:SetOwner(this, "ANCHOR_CURSOR");
			BankGUI:AddTooltip(GameTooltip, itemname);
			return;
		end
	end
end


function BankGUI_OnHyperlinkLeave()
	if not BankListOptions[GetRealmName()][1][BANKGUI_TOOLTIPS] then return end
	GameTooltip:Hide();
end


function BankGUI:SortItems()
	table.sort( BankListItems[GetRealmName()], function(a,b)
		return a["name"] < b["name"];
	end );
	table.sort( BankListItems[GetRealmName()], function(a,b)
		local nA = GetItemInfo(a["item"]);
		local nB = GetItemInfo(b["item"]);
		if nA == nil then nA = a["item"] end
		if nB == nil then nB = b["item"] end
		if a["name"] == b["name"] then return nA < nB
		else return a["name"] < b["name"] end
	end );
end


function BankGUI:OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_LOGIN");
	this:RegisterEvent("PLAYER_MONEY");
	this:RegisterEvent("PLAYER_GUILD_UPDATE");
	this:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
	this:RegisterEvent("BANKFRAME_OPENED");
	this:RegisterEvent("BANKFRAME_CLOSED");
	this:RegisterEvent("TRADE_SKILL_SHOW");
	this:RegisterEvent("GUILDBANKFRAME_OPENED");
	this:RegisterEvent("CURRENCY_DISPLAY_UPDATE");
	this:RegisterEvent("BAG_UPDATE");
	this:RegisterEvent("UPDATE_CHAT_COLOR");
	this:RegisterEvent("CHAT_MSG_WHISPER");
	this:RegisterEvent("CHAT_MSG_SYSTEM");
	this:RegisterEvent("AUCTION_HOUSE_CLOSED");
	this:RegisterEvent("AUCTION_HOUSE_SHOW");
	--this:RegisterAllEvents();
	bank_chat:AddMessage("|cffff8000" ..BINDING_HEADER_BANKGUI .."|r loaded. Go to |cffffff80Social (O)|r and select the |cffffff80Bank|r tab on the bottom right, or type |cffffff80/bank|r.", 0.5,1,1);
	SLASH_BANK1 = "/bank";
	SlashCmdList["BANK"] = function(msg)
		BankGUI:Bank_SlashCommandHandler(msg);
	end
end


local buttontexture;

function BankGUI:SetFriendsFrameSkin()

	BankGUIScrollFrameScrollBarScrollUpButton:SetNormalTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Up");
	BankGUIScrollFrameScrollBarScrollUpButton:SetPushedTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Down");
	BankGUIScrollFrameScrollBarScrollUpButton:SetDisabledTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Disabled");
	BankGUIScrollFrameScrollBarScrollUpButton:SetHighlightTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Highlight", "ADD");
	BankGUIScrollFrameScrollBarScrollDownButton:SetNormalTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Up");
	BankGUIScrollFrameScrollBarScrollDownButton:SetPushedTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Down");
	BankGUIScrollFrameScrollBarScrollDownButton:SetDisabledTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Disabled");
	BankGUIScrollFrameScrollBarScrollDownButton:SetHighlightTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Highlight", "ADD");
	BankGUIScrollFrameScrollBarTop:Show();
	BankGUIScrollFrameScrollBarBot:Show();
	BankGUIScrollFrameBorder:Hide();

	BankGUIDetailsFrame:SetBackdrop( { bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", tile = true, tileSize = 32, edgeSize = 32, insets = { left = 11, right = 11, top = 11, bottom = 10 } } );
	BankGUIDetailsFrameTopLine:Hide();
	BankGUIDetailsFrameBotLine:Hide();
	BankGUIDetailsCorner:Show();
	BankGUIDetailsCloseButtonText:SetText("");
	BankGUIDetailsCloseButton:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up");
	buttontexture = BankGUIDetailsCloseButton:GetNormalTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("BLEND");
	BankGUIDetailsCloseButton:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down");
	buttontexture = BankGUIDetailsCloseButton:GetPushedTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("BLEND");

	BankGUIFarmFrame:SetBackdrop( { bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", tile = true, tileSize = 32, edgeSize = 32, insets = { left = 11, right = 11, top = 11, bottom = 10 } } );
	BankGUIFarmFrameTopLine:Hide();
	BankGUIFarmFrameCharBack:Hide();
	BankGUIFarmFrameBotLine:Hide();
	BankGUIFarmCorner:Show();
	BankGUIFarmPlayerDropDownLeft:Show();
	BankGUIFarmPlayerDropDownMiddle:Show();
	BankGUIFarmPlayerDropDownRight:Show();
	BankGUIFarmCloseButtonText:SetText("");
	BankGUIFarmCloseButton:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up");
	buttontexture = BankGUIFarmCloseButton:GetNormalTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("BLEND");
	BankGUIFarmCloseButton:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down");
	buttontexture = BankGUIFarmCloseButton:GetPushedTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("BLEND");
	BankGUIFarmAddItem:SetNormalTexture("Interface\\Buttons\\UI-Panel-Button-Up");
	buttontexture = BankGUIFarmAddItem:GetNormalTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("BLEND");
	BankGUIFarmAddItem:SetHighlightTexture("Interface\\Buttons\\UI-Panel-Button-Highlight", "ADD");
	buttontexture = BankGUIFarmAddItem:GetHighlightTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("ADD");
	BankGUIFarmAddItem:SetPushedTexture("Interface\\Buttons\\UI-Panel-Button-Down");
	buttontexture = BankGUIFarmAddItem:GetPushedTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("BLEND");
	BankGUIFarmAddItem:SetDisabledTexture("Interface\\Buttons\\UI-Panel-Button-Disabled");
	buttontexture = BankGUIFarmAddItem:GetDisabledTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("ADD");
	BankGUIFarmCancelItem:SetNormalTexture("Interface\\Buttons\\UI-Panel-Button-Up");
	buttontexture = BankGUIFarmCancelItem:GetNormalTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("BLEND");
	BankGUIFarmCancelItem:SetHighlightTexture("Interface\\Buttons\\UI-Panel-Button-Highlight", "ADD");
	buttontexture = BankGUIFarmCancelItem:GetHighlightTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("ADD");
	BankGUIFarmCancelItem:SetPushedTexture("Interface\\Buttons\\UI-Panel-Button-Down");
	buttontexture = BankGUIFarmCancelItem:GetPushedTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("BLEND");
	BankGUIFarmCancelItem:SetDisabledTexture("Interface\\Buttons\\UI-Panel-Button-Disabled");
	buttontexture = BankGUIFarmCancelItem:GetDisabledTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("ADD");

	BankGUICloseButtonText:SetText("");
	BankGUICloseButton:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up");
	buttontexture = BankGUICloseButton:GetNormalTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("BLEND");
	BankGUICloseButton:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down");
	buttontexture = BankGUICloseButton:GetPushedTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("BLEND");
	BankGUIDeleteButton:SetNormalTexture("Interface\\Buttons\\UI-Panel-Button-Up");
	buttontexture = BankGUIDeleteButton:GetNormalTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("BLEND");
	BankGUIDeleteButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-Button-Highlight", "ADD");
	buttontexture = BankGUIDeleteButton:GetHighlightTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("ADD");
	BankGUIDeleteButton:SetPushedTexture("Interface\\Buttons\\UI-Panel-Button-Down");
	buttontexture = BankGUIDeleteButton:GetPushedTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("BLEND");
	BankGUIDeleteButton:SetDisabledTexture("Interface\\Buttons\\UI-Panel-Button-Disabled");
	buttontexture = BankGUIDeleteButton:GetDisabledTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("ADD");
	BankGUIFarmAddButton:SetText("");
	BankGUIFarmAddButton:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
	buttontexture = BankGUIFarmAddButton:GetNormalTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("BLEND");
	BankGUIFarmAddButton:SetPushedTexture("Interface\\Buttons\\UI-PlusButton-Down");
	buttontexture = BankGUIFarmAddButton:GetPushedTexture();
	buttontexture:SetVertexColor(0.999997,0.999997,0.999997,0.999997);
	buttontexture:SetBlendMode("BLEND");

	BankGUIPlayerDropDownLeft:Show();
	BankGUIPlayerDropDownMiddle:Show();
	BankGUIPlayerDropDownRight:Show();
	BankGUITypeDropDownLeft:Show();
	BankGUITypeDropDownMiddle:Show();
	BankGUITypeDropDownRight:Show();

	BankGUIFrameTopLine:Hide();
	BankGUIFrameCaption:Hide();
	BankGUIFrameMidLine:Hide();
	BankGUIFrameInfo:Hide();
	BankGUIFrameInfoLine:Hide();
	BankGUIFrameListBack:Hide();
	BankGUIFrameBackLine:Hide();
	BankGUIFrameCharBack:Hide();
	BankGUIFrameTypeBack:Hide();
	BankGUIFrameFilter:Hide();
	BankGUIFrameBotLine:Hide();
	BankGUIPlayerPortrait:Show();
	BankGUIFrameTopLeft:Show();
	BankGUIFrameTopRight:Show();
	BankGUIFrameBottomLeft:Show();
	BankGUIFrameBottomRight:Show();
	BankGUIDetailsFrame:SetAlpha(1.0);
	BankGUIFarmFrame:SetAlpha(1.0);
	BankGUIFrame:SetAlpha(1.0);
end


function BankGUI:SetBankGUIFrameSkin()

	BankGUIScrollFrameScrollBarScrollUpButton:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollUp-Up");
	BankGUIScrollFrameScrollBarScrollUpButton:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollUp-Down");
	BankGUIScrollFrameScrollBarScrollUpButton:SetDisabledTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollUp-Disabled");
	BankGUIScrollFrameScrollBarScrollUpButton:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight", "ADD");
	BankGUIScrollFrameScrollBarScrollDownButton:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Up");
	BankGUIScrollFrameScrollBarScrollDownButton:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Down");
	BankGUIScrollFrameScrollBarScrollDownButton:SetDisabledTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Disabled");
	BankGUIScrollFrameScrollBarScrollDownButton:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight", "ADD");
	BankGUIScrollFrameScrollBarTop:Hide();
	BankGUIScrollFrameScrollBarBot:Hide();
	BankGUIScrollFrameBorder:Show();

	BankGUIDetailsFrame:SetBackdrop( { bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", edgeFile = nil, tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 7, bottom = 7 } } );
	BankGUIDetailsFrameTopLine:Show();
	BankGUIDetailsFrameBotLine:Show();
	BankGUIDetailsCorner:Hide();
	BankGUIDetailsCloseButtonText:SetText("X");
	buttontexture = BankGUIDetailsCloseButton:GetNormalTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(0.5, 0.0, 0.0, 1.0);
	buttontexture = BankGUIDetailsCloseButton:GetPushedTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(0.2, 0.0, 0.0, 1.0);

	BankGUIFarmFrame:SetBackdrop( { bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", edgeFile = nil, tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 7, bottom = 7 } } ); --"Interface\\Tooltips\\UI-Tooltip-Border"
	BankGUIFarmFrameTopLine:Show();
	BankGUIFarmFrameCharBack:Show();
	BankGUIFarmFrameBotLine:Show();
	BankGUIFarmCorner:Hide();
	BankGUIFarmPlayerDropDownLeft:Hide();
	BankGUIFarmPlayerDropDownMiddle:Hide();
	BankGUIFarmPlayerDropDownRight:Hide();
	BankGUIFarmCloseButtonText:SetText("X");
	buttontexture = BankGUIFarmCloseButton:GetNormalTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(0.5, 0.0, 0.0, 1.0);
	buttontexture = BankGUIFarmCloseButton:GetPushedTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(0.2, 0.0, 0.0, 1.0);
	buttontexture = BankGUIFarmAddItem:GetNormalTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(0.5, 0.0, 0.0, 1.0);
	buttontexture = BankGUIFarmAddItem:GetHighlightTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(1.0, 0.0, 0.0, 1.0);
	buttontexture = BankGUIFarmAddItem:GetPushedTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(0.2, 0.0, 0.0, 1.0);
	buttontexture = BankGUIFarmAddItem:GetDisabledTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(0.33, 0.33, 0.33, 1.0);
	buttontexture = BankGUIFarmCancelItem:GetNormalTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(0.5, 0.0, 0.0, 1.0);
	buttontexture = BankGUIFarmCancelItem:GetHighlightTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(1.0, 0.0, 0.0, 1.0);
	buttontexture = BankGUIFarmCancelItem:GetPushedTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(0.2, 0.0, 0.0, 1.0);
	buttontexture = BankGUIFarmCancelItem:GetDisabledTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(0.33, 0.33, 0.33, 1.0);

	BankGUI:SetBankGUIBarColor();
	BankGUI:SetBankGUIBackgroundColor();

	BankGUICloseButtonText:SetText("X");
	buttontexture = BankGUICloseButton:GetNormalTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(0.5, 0.0, 0.0, 1.0);
	buttontexture = BankGUICloseButton:GetPushedTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(0.2, 0.0, 0.0, 1.0);
	buttontexture = BankGUIDeleteButton:GetNormalTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(0.5, 0.0, 0.0, 1.0);
	buttontexture = BankGUIDeleteButton:GetHighlightTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(1.0, 0.0, 0.0, 1.0);
	buttontexture = BankGUIDeleteButton:GetPushedTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(0.2, 0.0, 0.0, 1.0);
	buttontexture = BankGUIDeleteButton:GetDisabledTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(0.33, 0.33, 0.33, 1.0);
	BankGUIFarmAddButtonText:SetText("+");
	buttontexture = BankGUIFarmAddButton:GetNormalTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(0.5, 0.0, 0.0, 1.0);
	buttontexture = BankGUIFarmAddButton:GetPushedTexture();
	buttontexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight");
	buttontexture:SetBlendMode("ADD");
	buttontexture:SetVertexColor(0.2, 0.0, 0.0, 1.0);

	BankGUIPlayerDropDownLeft:Hide();
	BankGUIPlayerDropDownMiddle:Hide();
	BankGUIPlayerDropDownRight:Hide();
	BankGUITypeDropDownLeft:Hide();
	BankGUITypeDropDownMiddle:Hide();
	BankGUITypeDropDownRight:Hide();

	BankGUIPlayerPortrait:Show();
	BankGUIFrameTopLeft:Hide();
	BankGUIFrameTopRight:Hide();
	BankGUIFrameBottomLeft:Hide();
	BankGUIFrameBottomRight:Hide();
	BankGUIFrameTopLine:Show();
	BankGUIFrameCaption:Show();
	BankGUIFrameMidLine:Show();
	BankGUIFrameInfo:Show();
	BankGUIFrameInfoLine:Show();
	BankGUIFrameListBack:Show();
	BankGUIFrameBackLine:Show();
	BankGUIFrameCharBack:Show();
	BankGUIFrameTypeBack:Show();
	BankGUIFrameFilter:Show();
	BankGUIFrameBotLine:Show();

end


function BankGUI:SetBankFrameBackGround()
	if BankListOptions[GetRealmName()][1][ "detach" ] then
		if BankListOptions[GetRealmName()][1][ BANKGUI_BANKSKIN ] then
			BankGUI:SetBankGUIFrameSkin();
		else
			BankGUI:SetFriendsFrameSkin();
		end
		if BankListOptions[GetRealmName()][1][ BANKGUI_TRANSPARENT ] then
			if BankListOptions[GetRealmName()][1][ BANKGUI_BANKSKIN ] then BankGUIPlayerPortrait:Hide()
			else BankGUIPlayerPortrait:Show()
			end
			BankGUIFrame:SetAlpha(0.5);
			BankGUIDetailsFrame:SetAlpha(0.5);
			BankGUIFarmFrame:SetAlpha(0.5);
		else
			BankGUIFrame:SetAlpha(1.0);
			BankGUIDetailsFrame:SetAlpha(1.0);
			BankGUIFarmFrame:SetAlpha(1.0);
		end
	else
		BankGUI:SetFriendsFrameSkin();
		BankGUIFrame:SetAlpha(1.0);
		BankGUIDetailsFrame:SetAlpha(1.0);
		BankGUIFarmFrame:SetAlpha(1.0);
	end
end


function BankGUI:SetBankGUIBarColor()
	if BankListOptions[GetRealmName()][1][ BANKGUI_BARCOLOR ] == nil then return end
	local i;
	for i = 1, BANKGUIS_TO_DISPLAY do
		if BankListOptions[GetRealmName()][1][ BANKGUI_BARCOLOR ]["a"] ~= nil then
			_G["BankGUIButton" ..i]:GetHighlightTexture():SetVertexColor( BankListOptions[GetRealmName()][1][ BANKGUI_BARCOLOR ]["r"], BankListOptions[GetRealmName()][1][ BANKGUI_BARCOLOR ]["g"], BankListOptions[GetRealmName()][1][ BANKGUI_BARCOLOR ]["b"], BankListOptions[GetRealmName()][1][ BANKGUI_BARCOLOR ]["a"] );
		else
			_G["BankGUIButton" ..i]:GetHighlightTexture():SetVertexColor( BankListOptions[GetRealmName()][1][ BANKGUI_BARCOLOR ]["r"], BankListOptions[GetRealmName()][1][ BANKGUI_BARCOLOR ]["g"], BankListOptions[GetRealmName()][1][ BANKGUI_BARCOLOR ]["b"], 1.0 );
		end
	end
end


function BankGUI:SetBankGUIBackgroundColor()
	if BankListOptions[GetRealmName()][1][ BANKGUI_BACKCOLOR ] == nil then return end
	BankGUIFrameListBack:SetTexture( BankListOptions[GetRealmName()][1][ BANKGUI_BACKCOLOR ]["r"], BankListOptions[GetRealmName()][1][ BANKGUI_BACKCOLOR ]["g"], BankListOptions[GetRealmName()][1][ BANKGUI_BACKCOLOR ]["b"], BankListOptions[GetRealmName()][1][ BANKGUI_BACKCOLOR ]["a"] );
	BankGUIDetailsFrame:SetBackdropColor( BankListOptions[GetRealmName()][1][ BANKGUI_BACKCOLOR ]["r"], BankListOptions[GetRealmName()][1][ BANKGUI_BACKCOLOR ]["g"], BankListOptions[GetRealmName()][1][ BANKGUI_BACKCOLOR ]["b"], BankListOptions[GetRealmName()][1][ BANKGUI_BACKCOLOR ]["a"] );
	BankGUIFarmFrame:SetBackdropColor( BankListOptions[GetRealmName()][1][ BANKGUI_BACKCOLOR ]["r"], BankListOptions[GetRealmName()][1][ BANKGUI_BACKCOLOR ]["g"], BankListOptions[GetRealmName()][1][ BANKGUI_BACKCOLOR ]["b"], BankListOptions[GetRealmName()][1][ BANKGUI_BACKCOLOR ]["a"] );
end


function BankGUI:ResetBankGUIBarColor()
	BankListOptions[GetRealmName()][1][ BANKGUI_BARCOLOR ] = {};
	BankListOptions[GetRealmName()][1][ BANKGUI_BARCOLOR ]["r"] = 1.0;
	BankListOptions[GetRealmName()][1][ BANKGUI_BARCOLOR ]["g"] = 0.5;
	BankListOptions[GetRealmName()][1][ BANKGUI_BARCOLOR ]["b"] = 0.0;
	BankListOptions[GetRealmName()][1][ BANKGUI_BARCOLOR ]["a"] = 1.0;
end


function BankGUI:ResetBankGUIBackgroundColor()
	BankListOptions[GetRealmName()][1][ BANKGUI_BACKCOLOR ] = {};
	BankListOptions[GetRealmName()][1][ BANKGUI_BACKCOLOR ]["r"] = 0.05;
	BankListOptions[GetRealmName()][1][ BANKGUI_BACKCOLOR ]["g"] = 0.025;
	BankListOptions[GetRealmName()][1][ BANKGUI_BACKCOLOR ]["b"] = 0.0;
	BankListOptions[GetRealmName()][1][ BANKGUI_BACKCOLOR ]["a"] = 0.5;
end


function BankGUI:CheckChildFrames()
	if BankListOptions[GetRealmName()][1]["detach"] then
		BankGUIFarmFrame:ClearAllPoints();
		BankGUIDetailsFrame:ClearAllPoints();
		if ( BankGUIFrame:GetRight() + BankGUIFarmFrame:GetWidth() + 30 ) > GetScreenWidth() then
			BankGUIFarmFrame:SetPoint("TOPRIGHT", "BankGUIFrame", "TOPLEFT", 10, -220);
		else
			BankGUIFarmFrame:SetPoint("TOPLEFT", "BankGUIFrame", "TOPRIGHT", 30, -220);
		end
		if ( BankGUIFrame:GetRight() + BankGUIDetailsFrame:GetWidth() + 30 ) > GetScreenWidth() then
			BankGUIDetailsFrame:SetPoint("TOPRIGHT", "BankGUIFrame", "TOPLEFT", 10, -75);
		else
			BankGUIDetailsFrame:SetPoint("TOPLEFT", "BankGUIFrame", "TOPRIGHT", 30, -75);
		end
	end
end


function BankGUI:AddTooltip(tooltip, itemname, ...)
	if not BankListOptions[GetRealmName()][1][BANKGUI_TOOLTIPS] then return end
	if BankListStock and BankListStock[itemname] then
		if BankListStock[itemname]["stock"] ~= nil then
			if BankListStock[itemname]["self"] ~= nil then
				tooltip:AddLine( format("|cffff8000In Stock|r |cffffffff%i (%i)|r", BankListStock[itemname]["stock"], BankListStock[itemname]["self"]) );
			else
				tooltip:AddLine( format("|cffff8000In Stock|r |cffffffff%i|r", BankListStock[itemname]["stock"]) );
			end
		end
		if BankListStock[itemname]["bagged"] ~= nil then
			tooltip:AddLine( format("|cffff8000In Bags|r |cffffffff%i|r", BankListStock[itemname]["bagged"]) );
		end
		if BankListStock[itemname]["farm"] ~= nil then
			tooltip:AddLine( format("|cffff8000Farm|r |cffffffff%i|r |cff808080(%s)|r", BankListStock[ itemname ]["farm"]["amount"], BankListStock[itemname]["farm"]["date"]) );
		end
	end
	tooltip:Show();
end


function BankGUI:Convert()
	local i, x, y, bankinfo = 1, 0, 0, { };
	if not BankListCurrency then BankListCurrency = {} end
	if not BankListCurrency[GetRealmName()] then BankListCurrency[GetRealmName()] = {} end
	if not BankListFriends then BankListFriends = {} end
	if not BankListFriends[GetRealmName()] then BankListFriends[GetRealmName()] = {} end
	if not BankListGlyphs then BankListGlyphs = {} end
	if not BankListGlyphs[GetRealmName()] then BankListGlyphs[GetRealmName()] = {} end
	if not BankListFarms then BankListFarms = {} end
	if not BankListFarms[GetRealmName()] then BankListFarms[GetRealmName()] = {} end
	while true do
	  for i = 1, table.getn(BankListItems[GetRealmName()]) do
		if BankListItems[GetRealmName()][i]["type"] == BANKGUI_TYPE_CURRENCY then
			bankinfo = {};
			bankinfo["name"] = BankListItems[GetRealmName()][i]["name"];
			bankinfo["item"] = BankListItems[GetRealmName()][i]["item"];
			bankinfo["amount"] = BankListItems[GetRealmName()][i]["amount"];
			table.insert(BankListCurrency[GetRealmName()], bankinfo);
			table.remove(BankListItems[GetRealmName()], i);
			break;
		end
		if BankListItems[GetRealmName()][i]["type"] == BANKGUI_TYPE_FRIENDS then
			bankinfo = {};
			x, y = string.find(BankListItems[GetRealmName()][i]["item"], " ");
			if x then
				y = ( x - 1 );
				x = 1;
				bankinfo["name"] = string.sub(BankListItems[GetRealmName()][i]["item"], x, y);
			else
				bankinfo["name"] = BankListItems[GetRealmName()][i]["item"];
			end
			bankinfo["level"] = 0;
			bankinfo["class"] = "Unknown";
			x, y = string.find(BankListItems[GetRealmName()][i]["item"], "|cffffff80");
			if x then
				x = y + 1;
				y = ( string.len(BankListItems[GetRealmName()][i]["item"]) - 2 );
				bankinfo["note"] = string.sub(BankListItems[GetRealmName()][i]["item"], x, y);
			end
			table.insert(BankListFriends[GetRealmName()], bankinfo);
			table.remove(BankListItems[GetRealmName()], i);
			break;
		end
		if BankListItems[GetRealmName()][i]["type"] == BANKGUI_TYPE_GLYPHS then
			bankinfo = {};
			bankinfo["name"] = BankListItems[GetRealmName()][i]["name"];
			bankinfo["spec"] = GetActiveTalentGroup(false,false);
			bankinfo["item"] = BankListItems[GetRealmName()][i]["item"];
			bankinfo["slot"] = tonumber( BankListItems[GetRealmName()][i]["bank"] );
			table.insert(BankListGlyphs[GetRealmName()], bankinfo);
			table.remove(BankListItems[GetRealmName()], i);
			break;
		end
		if BankListItems[GetRealmName()][i]["type"] == BANKGUI_TYPE_FARMS then
			bankinfo = {};
			bankinfo["name"] = BankListItems[GetRealmName()][i]["name"];
			bankinfo["item"] = BankListItems[GetRealmName()][i]["item"];
			bankinfo["amount"] = BankListItems[GetRealmName()][i]["amount"];
			bankinfo["date"] = BankListItems[GetRealmName()][i]["bank"];
			table.insert(BankListFarms[GetRealmName()], bankinfo);
			table.remove(BankListItems[GetRealmName()], i);
			break;
		end
	  end
	  i = i + 1;
	  if table.getn(BankListItems[GetRealmName()]) == 0 then return end
	  if i >= table.getn(BankListItems[GetRealmName()]) then return end
	end
end


function BankGUI:UpdateCurrency()
	if not BankListOptions[GetRealmName()][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPCURR] then return end
	local i, j, bank_cl_name, bank_cl_header, bank_cl_amount, bank_cl_already;
	local bankinfo_curr = {};
	for i = 1, GetCurrencyListSize() do
		bank_cl_name, bank_cl_header, _, _, _, bank_cl_amount = GetCurrencyListInfo(i);
		if bank_cl_name and not bank_cl_header then
			bank_cl_already = false;
			for j = 1, table.getn(BankListCurrency[GetRealmName()]) do
				if BankListCurrency[GetRealmName()][j]["item"] == nil then
					table.remove(BankListCurrency[GetRealmName()], j);
				end
				if j > table.getn(BankListCurrency[GetRealmName()]) then break end
				if BankListCurrency[GetRealmName()][j]["name"] == bank_playername and BankListCurrency[GetRealmName()][j]["item"] == bank_cl_name then
					bank_cl_already = true;
					BankListCurrency[GetRealmName()][j]["amount"] = bank_cl_amount;
					break;
				end
			end
			if not bank_cl_already then
				bankinfo_curr = {};
				bankinfo_curr["name"] = bank_playername;
				bankinfo_curr["item"] = bank_cl_name;
				bankinfo_curr["amount"] = bank_cl_amount;
				table.insert(BankListCurrency[GetRealmName()], bankinfo_curr);
			end
		end
	end
	for j = 1, table.getn(BankListCurrency[GetRealmName()]) do
		if BankListCurrency[GetRealmName()][j]["item"] == nil then
			table.remove(BankListCurrency[GetRealmName()], j);
		end
		if j > table.getn(BankListCurrency[GetRealmName()]) then break end
	end
	table.sort(BankListCurrency[GetRealmName()], function(a,b)
		return a["name"] < b["name"]
	end );
	table.sort(BankListCurrency[GetRealmName()], function(a,b)
		if a["name"] == b["name"] then return a["item"] < b["item"] else return a["name"] < b["name"] end
	end );
end


function BankGUI:UpdateFriends()
	if not BankListOptions[GetRealmName()][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPFRIEND] then return end
	ShowFriends();
	local bank_friend_name, bank_friend_level, bank_friend_class, bank_friend_connected, bank_friend_note;
	local i, j, bank_friend_already, bank_friend_connected = 0, 0, false, false;
	local bankinfo_friend = nil;
	for i = 1, GetNumFriends() do
		bank_friend_name, bank_friend_level, bank_friend_class, _, bank_friend_connected, _, bank_friend_note = GetFriendInfo(i);
		if bank_friend_name then
			bank_friend_already = false;
			for j = 1, table.getn(BankListFriends[GetRealmName()]) do
				if BankListFriends[GetRealmName()][j]["name"] == nil then
					table.remove(BankListFriends[GetRealmName()], j);
				end
				if j > table.getn(BankListFriends[GetRealmName()]) then break end
				if BankListFriends[GetRealmName()][j]["name"] == bank_friend_name then
					bank_friend_already = true;
					if bank_friend_connected and bank_friend_level > 0 then
						BankListFriends[GetRealmName()][j]["level"] = bank_friend_level;
						BankListFriends[GetRealmName()][j]["class"] = bank_friend_class;
					else
						BankListFriends[GetRealmName()][j]["level"] = 0;
						BankListFriends[GetRealmName()][j]["class"] = "Unknown";
					end
					if bank_friend_note ~= nil and bank_friend_note ~= "" then
						BankListFriends[GetRealmName()][j]["note"] = bank_friend_note;
					end
					BankListFriends[GetRealmName()][j]["faction"] = bank_playerfaction;
				end
			end
			if not bank_friend_already then
				bankinfo_friend = {};
				bankinfo_friend["name"] = bank_friend_name;
				bankinfo_friend["level"] = bank_friend_level;
				bankinfo_friend["class"] = bank_friend_class;
				bankinfo_friend["note"] = bank_friend_note;
				bankinfo_friend["faction"] = bank_playerfaction;
				table.insert(BankListFriends[GetRealmName()], bankinfo_friend);
			end
		end
	end
	if BankListFriends ~= nil and BankListFriends[GetRealmName()] ~= nil then
		table.sort(BankListFriends[GetRealmName()], function(a,b) return (a["name"] < b["name"]) end );
		for i = 1, table.getn(BankListFriends[GetRealmName()]) do
			BankListFL[ BankListFriends[GetRealmName()][i]["name"] ] = {};
			BankListFL[ BankListFriends[GetRealmName()][i]["name"] ]["level"] = BankListFriends[GetRealmName()][i]["level"];
			BankListFL[ BankListFriends[GetRealmName()][i]["name"] ]["class"] = BankListFriends[GetRealmName()][i]["class"];
			BankListFL[ BankListFriends[GetRealmName()][i]["name"] ]["note"] = BankListFriends[GetRealmName()][i]["note"];
			if BankListFriends[GetRealmName()][i]["faction"] ~= nil then
				BankListFL[ BankListFriends[GetRealmName()][i]["name"] ]["faction"] = BankListFriends[GetRealmName()][i]["faction"];
			else
				BankListFL[ BankListFriends[GetRealmName()][i]["name"] ]["faction"] = "Unknown";
			end
		end
	end
end


function BankGUI:UpdateGlyphs()
	if not BankListOptions[GetRealmName()][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPGLYPS] then return end
	local glyph_enabled, glyph_type, glyph_SpellID, glyph_itemlink, glyph_already;
	local bankinfo_glyph = {};
	for i = 1, GetNumGlyphSockets() do
		glyph_SpellID, glyph_itemlink, glyph_already = nil, nil, false;
		glyph_enabled, glyph_type, glyph_SpellID, _ = GetGlyphSocketInfo(i);
		if ( glyph_enabled and glyph_SpellID ~= nil ) then
			glyph_itemlink = GetGlyphLink(i);
			if ( glyph_itemlink ) then
				for j = 1, table.getn(BankListGlyphs[GetRealmName()]) do
					if BankListGlyphs[GetRealmName()][j]["name"] == nil or BankListGlyphs[GetRealmName()][j]["item"] == nil then
						table.remove(BankListGlyphs[GetRealmName()], j);
					end
					if j > table.getn(BankListGlyphs[GetRealmName()]) then break end
					if BankListGlyphs[GetRealmName()][j]["spec"] == nil then BankListGlyphs[GetRealmName()][j]["spec"] = GetActiveTalentGroup(false,false) end
					if BankListGlyphs[GetRealmName()][j]["name"] == bank_playername and BankListGlyphs[GetRealmName()][j]["spec"] == GetActiveTalentGroup(false,false) and BankListGlyphs[GetRealmName()][j]["slot"] == i then
						glyph_already = true;
						BankListGlyphs[GetRealmName()][j]["item"] = glyph_itemlink;
						BankListGlyphs[GetRealmName()][j]["glyp"] = glyph_type;
						break;
					end
				end
				if not glyph_already then
					bankinfo_glyph = {};
					bankinfo_glyph["name"] = bank_playername;
					bankinfo_glyph["spec"] = GetActiveTalentGroup(false,false);
					bankinfo_glyph["item"] = glyph_itemlink;
					bankinfo_glyph["glyp"] = glyph_type;
					bankinfo_glyph["slot"] = i;
					table.insert(BankListGlyphs[GetRealmName()], bankinfo_glyph);
				end
			else
				for j = 1, table.getn(BankListGlyphs[GetRealmName()]) do
					if BankListGlyphs[GetRealmName()][j]["name"] == bank_playername and BankListGlyphs[GetRealmName()][j]["spec"] == GetActiveTalentGroup(false,false) and BankListGlyphs[GetRealmName()][j]["slot"] == i then
						table.remove(BankListItems[GetRealmName()], j);
						break;
					end
				end
			end
		end
	end
	table.sort(BankListGlyphs[GetRealmName()], function(a,b)
		return a["name"] < b["name"]
	end );
	table.sort(BankListGlyphs[GetRealmName()], function(a,b)
		if a["name"] == b["name"] then
			return a["spec"] < b["spec"]
		else
			return a["name"] < b["name"]
		end
	end );
	table.sort(BankListGlyphs[GetRealmName()], function(a,b)
		if a["name"] == b["name"] then
			if a["spec"] == b["spec"] then
				return a["slot"] < b["slot"]
			else
				return a["spec"] < b["spec"]
			end
		else
			return a["name"] < b["name"]
		end
	end );
end


function BankGUI:UpdateStock()
	local i, j, itemname, itemlink, itemrarity, itemcount, itemstack;
	BankListStock = {};
	for i = 1, table.getn(BankListItems[GetRealmName()]) do
		if ( (BankListOptions[GetRealmName()][1][BANKGUI_FACTION]) or (BankFactionColors[ BankListItems[GetRealmName()][i]["name"] ] and BankFactionColors[ BankListItems[GetRealmName()][i]["name"] ]["faction"] and BankFactionColors[ BankListItems[GetRealmName()][i]["name"] ]["faction"] == bank_playerfaction) )
		and (BankGUI:IsValidType(BankListItems[GetRealmName()][i])) then
			itemname, _, _, _, _, _, _, itemstack = GetItemInfo(BankListItems[GetRealmName()][i]["item"]);
			if itemname and itemstack > 1 then
				if not BankListStock[ itemname ] then BankListStock[ itemname ] = {} end
				if not BankListStock[ itemname ]["stock"] then BankListStock[ itemname ]["stock"] = 0 end
				if not BankListStock[ itemname ]["self"] then BankListStock[ itemname ]["self"] = 0 end
				BankListStock[ itemname ]["stock"] = BankListStock[ itemname ]["stock"] + BankListItems[GetRealmName()][i]["amount"];
				if BankListItems[GetRealmName()][i]["name"] == bank_playername then BankListStock[ itemname ]["self"] = BankListStock[ itemname ]["self"] + BankListItems[GetRealmName()][i]["amount"] end
			end
		end
	end
	for j = -2, -2 do
		for i = 1, GetContainerNumSlots(j) do
			itemlink = GetContainerItemLink(j, i);
			if itemlink then
				_, itemcount = GetContainerItemInfo(j, i);
				itemname, _, itemrarity, _, _, _, _, itemstack = GetItemInfo( itemlink );
				if ( itemname ~= nil and itemstack > 1 ) and ( itemrarity ~= nil and itemrarity > 0 ) then
					if not BankListStock[ itemname ] then BankListStock[ itemname ] = {} end
					if not BankListStock[ itemname ]["bagged"] then BankListStock[ itemname ]["bagged"] = 0 end
					BankListStock[ itemname ]["bagged"] = BankListStock[ itemname ]["bagged"] + itemcount;
				end
			end
		end
	end
	for j = 0, 4 do
		for i = 1, GetContainerNumSlots(j) do
			itemlink = GetContainerItemLink(j, i);
			if itemlink then
				_, itemcount = GetContainerItemInfo(j, i);
				itemname, _, itemrarity, _, _, _, _, itemstack = GetItemInfo( itemlink );
				if ( itemname ~= nil and itemstack > 1 ) and ( itemrarity ~= nil and itemrarity > 0 ) then
					if not BankListStock[ itemname ] then BankListStock[ itemname ] = {} end
					if not BankListStock[ itemname ]["bagged"] then BankListStock[ itemname ]["bagged"] = 0 end
					BankListStock[ itemname ]["bagged"] = BankListStock[ itemname ]["bagged"] + itemcount;
				end
			end
		end
	end
	for i = 1, table.getn(BankListCurrency[GetRealmName()]) do
		if BankListCurrency[GetRealmName()][i]["name"] == bank_playername then
			if not BankListStock[ BankListCurrency[GetRealmName()][i]["item"] ] then BankListStock[ BankListCurrency[GetRealmName()][i]["item"] ] = {} end
			if not BankListStock[ BankListCurrency[GetRealmName()][i]["item"] ]["stock"] then BankListStock[ BankListCurrency[GetRealmName()][i]["item"] ]["stock"] = 0 end
			BankListStock[ BankListCurrency[GetRealmName()][i]["item"] ]["stock"] = BankListStock[ BankListCurrency[GetRealmName()][i]["item"] ]["stock"] + BankListCurrency[GetRealmName()][i]["amount"];
		end
	end
	for i = 1, table.getn(BankListFarms[GetRealmName()]) do
		itemname, _, _, _, _, _, _, itemstack = GetItemInfo(BankListFarms[GetRealmName()][i]["item"]);
		if itemname == nil and BankListFarms[GetRealmName()][i]["item"] ~= nil then
			itemname = BankListFarms[GetRealmName()][i]["item"];
			itemstack = 20;
		end
		if itemname and itemstack > 1 then
			if not BankListStock[ itemname ] then BankListStock[ itemname ] = {} end
			if not BankListStock[ itemname ]["farm"] then BankListStock[ itemname ]["farm"] = {} end
			if not BankListStock[ itemname ]["farm"]["amount"] then BankListStock[ itemname ]["farm"]["amount"] = 0 end
			if not BankListStock[ itemname ]["farm"]["date"] then BankListStock[ itemname ]["farm"]["date"] = BankListFarms[GetRealmName()][i]["date"] end
			BankListStock[ itemname ]["farm"]["amount"] = BankListStock[ itemname ]["farm"]["amount"] + BankListFarms[GetRealmName()][i]["amount"];
			if BankListFarms[GetRealmName()][i]["date"] < BankListStock[ itemname ]["farm"]["date"] then BankListStock[ itemname ]["farm"]["date"] = BankListFarms[GetRealmName()][i]["date"] end
		end
	end
end


function BankGUI:HandleEvent(event)
--[[
	if ( string.find(event, "RE") ~= nil ) then
		local disp = event .."; ";
		if arg1 then disp = disp .."|cff00ff80 arg1: |r" .. arg1 end
		if arg2 then disp = disp .."|cff00ff80 arg2: |r" .. arg2 end
		if arg3 then disp = disp .."|cff00ff80 arg3: |r" .. arg3 end
		if arg4 then disp = disp .."|cff00ff80 arg4: |r" .. arg4 end
		if arg5 then disp = disp .."|cff00ff80 arg5: |r" .. arg5 end
		if arg6 then disp = disp .."|cff00ff80 arg6: |r" .. arg6 end
		if arg7 then disp = disp .."|cff00ff80 arg7: |r" .. arg7 end
		if arg8 then disp = disp .."|cff00ff80 arg8: |r" .. arg8 end
		if arg9 then disp = disp .."|cff00ff80 arg9: |r" .. arg9 end
		if arg10 then disp = disp .."|cff00ff80 arg10: |r" .. arg10 end
		if arg11 then disp = disp .."|cff00ff80 arg11: |r" .. arg11 end
		if arg12 then disp = disp .."|cff00ff80 arg12: |r" .. arg12 end
		if arg13 then disp = disp .."|cff00ff80 arg13: |r" .. arg13 end
		if arg14 then disp = disp .."|cff00ff80 arg14: |r" .. arg14 end
		if arg15 then disp = disp .."|cff00ff80 arg15: |r" .. arg15 end
		if arg16 then disp = disp .."|cff00ff80 arg16: |r" .. arg16 end
		ChatFrame1:AddMessage( disp );
		return;
	end
--]]

	if (event == "VARIABLES_LOADED") then
		local playerinfo = { ["name"] = "", ["money"] = 0, ["faction"] = UnitFactionGroup("player") };
		local optionsinfo = { ["detach"] = false, ["guild_checked"] = false, ["guild_name"] = nil, ["player_name"] = nil, ["player_type"] = 1, [BANKGUI_ALTHOOVER] = false };
		local i, element_exists, subarray = 0, false;
		if not BankListOptions then BankListOptions = {} end
		if not BankListOptions[GetRealmName()] then BankListOptions[GetRealmName()] = {} end
		if not BankListOptions[GetRealmName()][1] then
			table.insert( BankListOptions[GetRealmName()], optionsinfo );
		end

		if BankListOptions[GetRealmName()][1]["detach"] == nil then BankListOptions[GetRealmName()][1]["detach"] = false end
		if BankListOptions[GetRealmName()][1][BANKGUI_FACTION] == nil then BankListOptions[GetRealmName()][1][BANKGUI_FACTION] = false end
		if BankListOptions[GetRealmName()][1][BANKGUI_TOTALS] == nil then BankListOptions[GetRealmName()][1][BANKGUI_TOTALS] = false end
		if BankListOptions[GetRealmName()][1][BANKGUI_ALTHOOVER] == nil then BankListOptions[GetRealmName()][1][BANKGUI_ALTHOOVER] = false end

		for subarray in pairs(BANKGUI_OPTIONS_MENU) do
			if subarray == BANKGUI_KEEPTRACKOF then
				if not BankListOptions[GetRealmName()][1][ subarray ] then BankListOptions[GetRealmName()][1][ subarray ] = {} end
				for i = 1, table.getn(BANKGUI_OPTIONS_MENU[ subarray ]) do
					if BankListOptions[GetRealmName()][1][subarray][ BANKGUI_OPTIONS_MENU[subarray][i] ] == nil then BankListOptions[GetRealmName()][1][subarray][ BANKGUI_OPTIONS_MENU[subarray][i] ] = true end
				end
			end
			if string.find(subarray, "Sort Order") ~= nil then
				if not BankListOptions[GetRealmName()][1][subarray] then BankListOptions[GetRealmName()][1][subarray] = { } end
				if not BankListOptions[GetRealmName()][1][subarray]["name"] then
					if string.find(subarray, "1") ~= nil then BankListOptions[GetRealmName()][1][subarray]["name"] = BANKGUI_SORTNAME1 end
					if string.find(subarray, "2") ~= nil then BankListOptions[GetRealmName()][1][subarray]["name"] = BANKGUI_SORTNAME2 end
					if string.find(subarray, "3") ~= nil then BankListOptions[GetRealmName()][1][subarray]["name"] = BANKGUI_SORTNAME3 end
				end
			end
		end
		for i = 1, table.getn(BANKGUI_OPTIONS_MENU) do
			if BANKGUI_OPTIONS_MENU[i]["name"] ~= nil then
				if BANKGUI_OPTIONS_MENU[i]["checkable"] == true then
					if BankListOptions[GetRealmName()][1][ BANKGUI_OPTIONS_MENU[i]["name"] ] == nil then
						BankListOptions[GetRealmName()][1][ BANKGUI_OPTIONS_MENU[i]["name"] ] = false;
					end
				end
			end
		end

		TypesIndex = BankListOptions[GetRealmName()][1]["player_type"];

		if not BankListGuildInfo then BankListGuildInfo = {} end
		if not BankListGuildInfo[GetRealmName()] then BankListGuildInfo[GetRealmName()] = {} end

		if not BankListGuildItems then BankListGuildItems = {} end
		if not BankListGuildItems[GetRealmName()] then BankListGuildItems[GetRealmName()] = {} end

		if BankListFriends == nil then BankListFriends = {} end
		if BankListFriends[GetRealmName()] == nil then BankListFriends[GetRealmName()] = {} end

		bank_playername = UnitName("player");
		bank_playerfaction = UnitFactionGroup("player");

		playerinfo["name"] = bank_playername;
		playerinfo["money"] = GetMoney();
		
		if not BankFilter then BankFilter = {} end
		--if not BankFilter[GetRealmName()] then BankFilter[GetRealmName()] = {} end
		if not BankTotals then BankTotals = {} end
		if not BankListItems then BankListItems = {} end
		if not BankListItems[GetRealmName()] then BankListItems[GetRealmName()] = {} end
		if not BankListPlayers then BankListPlayers = {} end
		if not BankListPlayers[GetRealmName()] then BankListPlayers[GetRealmName()] = {} end
		if bank_playername then
			element_exists = false;
			for i = 1, table.getn(BankListPlayers[GetRealmName()]) do
				if BankListPlayers[GetRealmName()][i]["name"] == bank_playername then
					BankListPlayers[GetRealmName()][i]["money"] = GetMoney();
					BankListPlayers[GetRealmName()][i]["faction"] = bank_playerfaction;
					element_exists = true;
				end
				if not BankFactionColors[ BankListPlayers[GetRealmName()][i]["name"] ] then BankFactionColors[ BankListPlayers[GetRealmName()][i]["name"] ] = {} end
				BankFactionColors[ BankListPlayers[GetRealmName()][i]["name"] ]["faction"] = "Unknown";
				if BankListPlayers[GetRealmName()][i]["faction"] then
					BankFactionColors[ BankListPlayers[GetRealmName()][i]["name"] ]["faction"] = BankListPlayers[GetRealmName()][i]["faction"]
				else
					BankFactionColors[ BankListPlayers[GetRealmName()][i]["name"] ]["faction"] = "Unknown"
				end
			end
			if not element_exists then
				table.insert( BankListPlayers[GetRealmName()], playerinfo );
				table.sort( BankListPlayers[GetRealmName()], function(a,b) return a["name"] < b["name"] end );
			end
			local wispinfo = { ["name"] = UnitName("player") };
			table.insert(Wisp_Data, wispinfo);
		end

		if not BankListOptions[GetRealmName()][1]["RunOnceConvert"] then
			BankGUI:Convert();
			BankListOptions[GetRealmName()][1]["RunOnceConvert"] = true;
		end

		BankGUI:InsertUI();

		if BankListOptions[GetRealmName()][1]["detach"] and BankListOptions[GetRealmName()][1]["pos"] then
			BankGUIFrame:SetPoint(BankListOptions[GetRealmName()][1]["pos"]["point"], "UIParent", BankListOptions[GetRealmName()][1]["pos"]["relativePoint"], BankListOptions[GetRealmName()][1]["pos"]["xOfs"], BankListOptions[GetRealmName()][1]["pos"]["yOfs"]);
		end

		if ChatFrame1 then
			ChatFrame1:HookScript("OnHyperlinkClick", BankGUI_OnHyperlinkClick);
			ChatFrame1:HookScript("OnHyperlinkEnter", BankGUI_OnHyperlinkEnter);
			ChatFrame1:HookScript("OnHyperlinkLeave", BankGUI_OnHyperlinkLeave);
		end
		if ChatFrame2 then
			ChatFrame2:HookScript("OnHyperlinkClick", BankGUI_OnHyperlinkClick);
			ChatFrame2:HookScript("OnHyperlinkEnter", BankGUI_OnHyperlinkEnter);
			ChatFrame2:HookScript("OnHyperlinkLeave", BankGUI_OnHyperlinkLeave);
		end
		if ChatFrame3 then
			ChatFrame3:HookScript("OnHyperlinkClick", BankGUI_OnHyperlinkClick);
			ChatFrame3:HookScript("OnHyperlinkEnter", BankGUI_OnHyperlinkEnter);
			ChatFrame3:HookScript("OnHyperlinkLeave", BankGUI_OnHyperlinkLeave);
		end
		if ChatFrame4 then
			ChatFrame4:HookScript("OnHyperlinkClick", BankGUI_OnHyperlinkClick);
			ChatFrame4:HookScript("OnHyperlinkEnter", BankGUI_OnHyperlinkEnter);
			ChatFrame4:HookScript("OnHyperlinkLeave", BankGUI_OnHyperlinkLeave);
		end
		if ChatFrame5 then
			ChatFrame5:HookScript("OnHyperlinkClick", BankGUI_OnHyperlinkClick);
			ChatFrame5:HookScript("OnHyperlinkEnter", BankGUI_OnHyperlinkEnter);
			ChatFrame5:HookScript("OnHyperlinkLeave", BankGUI_OnHyperlinkLeave);
		end

		if GameTooltip then
			GameTooltip:HookScript("OnTooltipSetItem",
			function(tooltip, ...)
				if not BankListOptions[GetRealmName()][1][BANKGUI_TOOLTIPS] then return end
				local itemname, itemlink = tooltip:GetItem();
				if itemname == nil then return end
				if BankListStock[itemname] then
					tooltip:AddLine( " " );
					BankGUI:AddTooltip(tooltip, itemname);
				end
				if IsShiftKeyDown() and IsAltKeyDown() and BankListOptions[GetRealmName()][1][BANKGUI_ALTHOOVER] then
					if itemname then
						BankGUIFrame:Show();
						BankGUIFilterTextBox:SetText("");
						BankGUIFilterTextBox:Insert(itemname);
						BankGUIFilterTextBox:SetCursorPosition(0);
					end
				elseif IsShiftKeyDown() then
					local itemlevel, itemminlevel;
					_, _, _, itemlevel, itemminlevel = GetItemInfo(itemlink);
					tooltip:AddLine( " " );
					tooltip:AddLine( format("|cffff8000MinLvl / Lvl|r |cffffffff%i / %i|r", itemminlevel, itemlevel) );
				elseif IsAltKeyDown() and BankListOptions[GetRealmName()][1][BANKGUI_ALTHOOVER] then
					if not bank_ahopened then
						if not BankGUIFrame:IsVisible() then BankGUI:ToggleTab() end
						BankGUIFarmFrame:Show();
						BankGUIFarmItemBox:SetText("");
						BankGUIFarmItemBox:Insert(itemlink);
						BankGUIFarmItemBox:SetCursorPosition(0);
						if BankGUIFarmAmountBox:GetNumber() == 0 then BankGUIFarmAmountBox:Insert("1") end
						BankGUIFarmAmountBox:SetFocus();
					end
				end
			end );
		end

		return;
	end

	if (event == "PLAYER_LOGIN") then
		local playerinfo = {["name"] = "", ["money"] = 0, };
		local i, j, element_exists = 0, 0, false;
		bank_playername = UnitName("player");
		if bank_playername then
			playerinfo["money"] = GetMoney();
			element_exists = false;
			for i = 1, table.getn(BankListPlayers[GetRealmName()]) do
				if BankListPlayers[GetRealmName()][i]["name"]==bank_playername then
					BankListPlayers[GetRealmName()][i]["money"] = GetMoney();
					element_exists = true;
				end
			end
			if not element_exists then
				table.insert( BankListPlayers[GetRealmName()], playerinfo );
				BankListPlayers[GetRealmName()][table.getn(BankListPlayers[GetRealmName()])]["money"] = GetMoney();
				table.sort( BankListPlayers[GetRealmName()], function(a,b) return a["name"] < b["name"] end );
			end
		end

		BankGUI:SetBankGUIBarColor();
		BankGUI:SetBankFrameBackGround();

		BankGUI:UpdateFriends();
		BankGUI:UpdateGlyphs();
		BankGUI:UpdateStock();

		BankGUIDetachCheckButton:SetChecked(BankListOptions[GetRealmName()][1]["detach"]);

		BankGUIGuildCheckButton:SetChecked(BankListOptions[GetRealmName()][1]["guild_checked"]);
		BankGUIGuildCheckButton_OnClick(BankGUIGuildCheckButton);

		BankGUI:UpdateFilter(nil);

		return;
	end

	if (event == "PLAYER_MONEY") then
		local bank_gold_tot = 0.0;
		bank_playername = UnitName("player");
		for i = 1, table.getn(BankListPlayers[GetRealmName()]) do
			if BankListPlayers[GetRealmName()][i]["name"]==bank_playername then
				BankListPlayers[GetRealmName()][i]["money"] = GetMoney();
			end
			bank_gold_tot = bank_gold_tot + (BankListPlayers[GetRealmName()][i]["money"]/10000);
		end
		if not BankListOptions[GetRealmName()][1]["guild_checked"] then BankGUITotalGold:SetText( format(BANKGUI_GOLD_BANK,bank_gold_tot) ) end
		return;
	end

	if (event == "PLAYER_GUILD_UPDATE") then
		local guildinfo = {["name"] = "", ["money"] = 0, };
		local i, element_exists, bank_temp_guildname = 0, false;
		bank_temp_guildname = GetGuildInfo("player");
		if bank_guildname and bank_guildname == bank_temp_guildname then return end
		bank_guildname = GetGuildInfo("player");
		if bank_guildname then
			if not BankListGuildItems[GetRealmName()][bank_guildname] then BankListGuildItems[GetRealmName()][bank_guildname] = {} end
			guildinfo["name"] = bank_guildname;
			for i = 1, table.getn(BankListGuildInfo[GetRealmName()]) do
				if BankListGuildInfo[GetRealmName()][i]["name"] == bank_guildname then element_exists = true end
			end
			if not element_exists then table.insert(BankListGuildInfo[GetRealmName()], guildinfo) end
		end
		return;
	end

	if (event == "ACTIVE_TALENT_GROUP_CHANGED") then
		BankGUI:UpdateGlyphs();
		BankGUI:UpdateStock();
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
		return;
	end

	if (event == "CURRENCY_DISPLAY_UPDATE") then
		BankGUI:UpdateCurrency();
		BankGUI:UpdateStock();
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
		return;
	end

	if (event == "UPDATE_CHAT_COLOR") then
		if arg1 == "GUILD" then
			bank_guildcolor_on = format("|cff%.2X%.2X%.2X", arg2*255, arg3*255, arg4*255);
			bank_guildcolor_of = format("|cff%.2X%.2X%.2X", arg2*85, arg3*85, arg4*85);
			--if BankGUIFrame:IsVisible() then BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText()) end
		end
		return;
	end

	if (event == "BAG_UPDATE") then
		if bank_frame_opened then return end
		if not BankListOptions[GetRealmName()][1][BANKGUI_TOOLTIPS] then return end
		if arg1 == -4 then return end
		local subarray, itemlink, itemname, itemcount, itemstack;
		for subarray in pairs(BankListStock) do
			BankListStock[ subarray ]["bagged"] = 0;
		end
		for j = -2, -2 do
			for i = 1, GetContainerNumSlots(j) do
				itemlink = GetContainerItemLink(j, i);
				if itemlink then
					_, itemcount = GetContainerItemInfo(j, i);
					itemname, _, itemrarity, _, _, _, _, itemstack = GetItemInfo( itemlink );
					if ( itemname ~= nil and itemstack > 1 ) and ( itemrarity ~= nil and itemrarity > 0 ) then
						if not BankListStock[ itemname ] then
							BankListStock[ itemname ] = {};
							BankListStock[ itemname ]["bagged"] = 0;
						end
						BankListStock[ itemname ]["bagged"] = BankListStock[ itemname ]["bagged"] + itemcount;
					end
				end
			end
		end
		for j = 0, 4 do
			for i = 1, GetContainerNumSlots(j) do
				itemlink = GetContainerItemLink(j, i);
				if itemlink then
					_, itemcount = GetContainerItemInfo(j, i);
					itemname, _, itemrarity, _, _, _, _, itemstack = GetItemInfo( itemlink );
					if ( itemname ~= nil and itemstack > 1 ) and ( itemrarity ~= nil and itemrarity > 0 ) then
						if not BankListStock[ itemname ] then
							BankListStock[ itemname ] = {};
							BankListStock[ itemname ]["bagged"] = 0;
						end
						BankListStock[ itemname ]["bagged"] = BankListStock[ itemname ]["bagged"] + itemcount;
					end
				end
			end
		end
		for subarray in pairs(BankListStock) do
			if BankListStock[ subarray ]["bagged"] and BankListStock[ subarray ]["bagged"] <= 0 then
				BankListStock[ subarray ]["bagged"] = nil;
			end
			if BankListStock[ subarray ]["stock"] and BankListStock[ subarray ]["stock"] <= 0 then
				BankListStock[ subarray ]["stock"] = nil;
			end
			if BankListStock[ subarray ]["bagged"] == nil and BankListStock[ subarray ]["stock"] == nil and BankListStock[ subarray ]["farm"] == nil then BankListStock[ subarray ] = nil end
		end
		return;
	end

	if ( event == "BANKFRAME_OPENED" ) then
		bank_frame_opened = true;
		if not BankListOptions[GetRealmName()][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPITEMS] then return end
		local i, j, k, itemlink, itemcount;
		local bank_keepremoving = true;
		while bank_keepremoving do
			k = BankGUI:GetBankItemIndexByName(bank_playername);
			if k == 0 then bank_keepremoving = false
			else
				table.remove( BankListItems[GetRealmName()], k )
			end
		end
		k = 1;
		for j = -2, 11 do
			for i = 1, GetContainerNumSlots(j) do
				itemlink = GetContainerItemLink(j,i);
				_, itemcount = GetContainerItemInfo(j,i);
				if itemlink then BankGUI:AddItem(itemlink, itemcount, true, nil, false, j) end
			end
		end
		for i = 0, 19 do
			itemlink = GetInventoryItemLink("player", i);
			if itemlink then BankGUI:AddItem(itemlink, 1, true, "-3", false, nil) end
		end
		BankGUI:SortItems();
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
		return;
	end

	if ( event == "BANKFRAME_CLOSED" ) then
		BankGUI:UpdateStock();
		bank_frame_opened = false;
		return;
	end

	if ( event == "TRADE_SKILL_SHOW" ) then
		local islinked, islinkedname = IsTradeSkillLinked();
		if islinked and arg2 then
			if not BankListOptions[GetRealmName()][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPPROFS] then return end
			local tradeinfo, tradetitlestr, i, j = { }, nil, string.find(arg2,"|Htrade");
			if i ~= nil then
				j = string.find(arg2, "|h|r");
				i = string.find(arg2, "|h", (i+7));
				tradetitlestr = string.sub(arg2, (i+3), (j-2));
				if tradetitlestr == nil then return end
			end
			for i = 1, table.getn(BankListItems[GetRealmName()]) do
				if BankListItems[GetRealmName()][i]["type"] == BANKGUI_TYPE_TRADELINK and BankListItems[GetRealmName()][i]["name"] == islinkedname and string.find(BankListItems[GetRealmName()][i]["item"], tradetitlestr) ~= nil then
					BankListItems[GetRealmName()][i]["item"] = arg2;
					BankListItems[GetRealmName()][i]["amount"] = date("%d/%m/%y %H:%M");
					BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
					return;
				end
			end
			tradeinfo["type"] = BANKGUI_TYPE_TRADELINK;
			tradeinfo["name"] = islinkedname;
			tradeinfo["amount"] = date("%d/%m/%y %H:%M");
			tradeinfo["item"] = arg2;
			tradeinfo["bank"] = false;
			table.insert(BankListItems[GetRealmName()], tradeinfo);
			table.sort( BankListItems[GetRealmName()], function(a,b)
				local i = string.find(a["item"],"|h")
				local j = string.find(b["item"],"|h")
				if i == nil then i = 1 end
				if j == nil then j = 1 end
				if a["name"] == b["name"] then return string.sub(a["item"],i) < string.sub(b["item"],j)
				else return a["name"] < b["name"] end
				end
			);
			BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
			return;
		end
		if not BankListOptions[GetRealmName()][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPTRADE] then return end
		local i = 0;
		local sName, sType, itemlink;
		for i = 1, GetNumTradeSkills() do
			sName, sType = GetTradeSkillInfo(i);
			if ( sName and sType ~= "header" ) then
				itemlink = GetTradeSkillRecipeLink(i);
				if not BankGUI:GetSkillItemByName(itemlink, sType) then BankGUI:AddItem(itemlink, 1, false, sType, false, nil) end
			end
		end
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
		return;
	end

	if ( event == "GUILDBANKFRAME_OPENED" ) then
		if not BankListOptions[GetRealmName()][1][BANKGUI_KEEPTRACKOF][BANKGUI_KEEPGUILD] then return end
		local i, j, k, itemlink, itemcount;
		local guildinfo = {["name"] = "", ["money"] = 0 };
		local element_exists = false;
		bank_guildname = GetGuildInfo("player");
		if not BankListGuildItems then BankListGuildItems = {} end
		if not BankListGuildItems[GetRealmName()] then BankListGuildItems[GetRealmName()] = {} end
		if bank_guildname then
			guildinfo["name"] = bank_guildname;
			guildinfo["money"] = GetGuildBankMoney();
			if not BankListGuildInfo then BankListGuildInfo = {} end
			if not BankListGuildInfo[GetRealmName()] then BankListGuildInfo[GetRealmName()] = {} end
			for i = 1, table.getn(BankListGuildInfo[GetRealmName()]) do
				if BankListGuildInfo[GetRealmName()][i]["name"] == bank_guildname then
					element_exists = true;
					BankListGuildInfo[GetRealmName()][i]["money"] = guildinfo["money"];
				end
			end
			if not element_exists then table.insert(BankListGuildInfo[GetRealmName()], guildinfo) end
		end
		BankListGuildItems[GetRealmName()][bank_guildname] = {};
		for j = 1, GetNumGuildBankTabs() do
			for i = 1, 98 do
				itemlink = GetGuildBankItemLink(j,i);
				_, itemcount = GetGuildBankItemInfo(j,i);
				if itemlink then BankGUI:AddItem(itemlink, itemcount, true, nil, true, j) end
			end
		end
		table.sort( BankListGuildItems[GetRealmName()][bank_guildname], function(a,b)
			local i = string.find(a["item"],"|h")
			local j = string.find(b["item"],"|h")
			return string.sub(a["item"],i) < string.sub(b["item"],j)
			end
		);
		BankGUIGuildCheckButton_OnClick(BankGUIGuildCheckButton);
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
		return;
	end

	if (event == "CHAT_MSG_WHISPER") then
		local wispinfo = { ["name"] = arg2 };
		local i, element_exists = 1, false;
		for i = 1, table.getn(Wisp_Data) do
			if Wisp_Data[i]["name"] == arg2 then
				element_exists = true;
				break;
			end
		end
		if not element_exists then
			table.insert(Wisp_Data, wispinfo);
			table.sort(Wisp_Data, function(a,b) return a["name"] < b["name"] end );
		end
		if ( string.sub(arg1, 1, 1) == "!" and string.len(arg1) > 1 ) then
			local craftable = string.lower( string.sub(arg1, 2) );
			local j, subarray = 0;
			for subarray in pairs(BankListStock) do
				if ( string.find(string.lower(subarray), craftable) ~= nil ) then
					if j < 10 then SendChatMessage( format("[%s]x%i", subarray, BankListStock[subarray]["stock"]), "WHISPER", nil, arg2)
					else
						SendChatMessage("--- Too many items found. Listing is stopped. ---", "WHISPER", nil, arg2);
						break;
					end
					j = j + 1;
				end
			end
		end
		return;
	end

	if (event == "CHAT_MSG_SYSTEM") then
		if arg6 ~= nil and arg6 == "MOTD" then return end
		if arg1 ~= nil then
			local bank_friend_name, bank_friend_level, bank_friend_class, bank_friend_note, bank_fl_name;
			local i, j = string.find(arg1, "|Hplayer");
			if i ~= nil then
				i = string.find(arg1, "[[]", j);
				i = i + 1;
				_, j = string.find(arg1, "[]]", i);
				j = j - 1;
				if string.sub(arg1, i, j) == bank_playername then return end
				bank_fl_name = string.sub(arg1, i, j);
				if BankListFL[bank_fl_name] ~= nil then
					ShowFriends();
					for i = 1, GetNumFriends() do
						bank_friend_name, bank_friend_level, bank_friend_class, _, _, _, bank_friend_note = GetFriendInfo(i);
						if bank_friend_name == bank_fl_name then
							for j = 1, table.getn(BankListFriends[GetRealmName()]) do
								if BankListFriends[GetRealmName()][j]["name"] == bank_fl_name then
									if BankListFriends[GetRealmName()][j]["level"] ~= bank_friend_level then
										BankListFriends[GetRealmName()][j]["level"] = bank_friend_level;
										BankListFL[bank_fl_name]["level"] = bank_friend_level;
									end
									if BankListFriends[GetRealmName()][j]["class"] ~= bank_friend_class then
										BankListFriends[GetRealmName()][j]["class"] = bank_friend_class;
										BankListFL[bank_fl_name]["class"] = bank_friend_class;
									end
									if BankListFriends[GetRealmName()][j]["note"] ~= nil and BankListFriends[GetRealmName()][i]["note"] ~= bank_friend_note then
										BankListFriends[GetRealmName()][j]["note"] = bank_friend_note;
										BankListFL[bank_fl_name]["note"] = bank_friend_note;
									end
								end
							end
							return;
						end
					end
				end
			end
		end
		return;
	end

	if ( event == "AUCTION_HOUSE_CLOSED" ) then
		bank_ahopened = false;
		return;
	end

	if ( event == "AUCTION_HOUSE_SHOW" ) then
		bank_ahopened = true;
		return;
	end

end


local bank_endtext = "|cffff8000"..BANKGUI_TITLE .."|r End.";

function BankGUI:Bank_SlashCommandHandler(msg)
	if msg == nil or msg == "" then
		BankGUI:ToggleTab()
	elseif msg == "help" or msg == "?" then
		local i;
		bank_chat:AddMessage(" ");
		for i = 1, table.getn(BANKGUI_HELP) do
			bank_chat:AddMessage(BANKGUI_HELP[i][1], BANKGUI_HELP[i][2], BANKGUI_HELP[i][3], BANKGUI_HELP[i][4]);
		end
	elseif msg == "update" then
		BankGUI:UpdateCurrency();
		BankGUI:UpdateFriends();
		BankGUI:UpdateGlyphs();
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
	elseif msg == "detach" then
		BankGUIDetachCheckButton:SetChecked(true);
		BankGUIDetachCheckButton_OnClick();
	elseif msg == "attach" then
		BankGUIDetachCheckButton:SetChecked(false);
		BankGUIDetachCheckButton_OnClick();
	elseif msg == "sort" then
		BankGUI:SortItems();
	elseif msg == "check" then
		local i, j, itemname, itemlink, itemcount, itemstack;
		local bank_stackcheck = {};
		bank_chat:AddMessage( "|cffff8000"..BANKGUI_TITLE .."|r Stack Check...");
		for j = -2, 11 do
			for i = 1, GetContainerNumSlots(j) do
				itemlink = GetContainerItemLink(j, i);
				if itemlink then
					_, itemcount = GetContainerItemInfo(j, i);
					itemname, _, _, _, _, _, _, itemstack = GetItemInfo(itemlink);
					if itemstack and itemstack > 1 and itemcount < itemstack then
						if not bank_stackcheck[itemname] then
							bank_stackcheck[itemname] = {};
							bank_stackcheck[itemname]["s"] = itemstack;
							bank_stackcheck[itemname]["c"] = itemcount;
						else
							if j <= 4 then bank_chat:AddMessage( " BAGS: " ..itemlink)
							else bank_chat:AddMessage( " BANK: " ..itemlink)
							end
						end
					end
				end
			end
		end
		bank_chat:AddMessage( bank_endtext );
	elseif msg == "grey" then
		local i, j, itemlink, itemrarity;
		bank_chat:AddMessage( "|cffff8000"..BANKGUI_TITLE .."|r Grey Item Check...");
		for j = -2, 11 do
			for i = 1, GetContainerNumSlots(j) do
				itemlink = GetContainerItemLink(j, i);
				if itemlink then
					_, _, itemrarity = GetItemInfo(itemlink);
					if itemrarity <= 0 then
						bank_chat:AddMessage( format("|cffff8000%s|r %s", BANKGUI_TITLE, itemlink) );
					end
				end
			end
		end
		bank_chat:AddMessage( bank_endtext );
	elseif string.find(msg, "|Hitem") then
		msg = GetItemInfo(msg);
		BankGUIFilterTextBox:SetText(msg);
		BankGUI:ToggleTab();
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
	else
		BankGUIFilterTextBox:SetText(msg);
		BankGUI:ToggleTab();
		BankGUI:UpdateFilter(BankGUIFilterTextBox:GetText());
	end
end
